package cn.com.infosec.jce;

import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DEROutputStream;
import cn.com.infosec.asn1.x509.X509Name;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.security.Principal;
import java.util.Hashtable;
import java.util.Vector;

public class X509Principal extends X509Name implements Principal {
   private static ASN1Sequence readSequence(ASN1InputStream aIn) {
      try {
         return ASN1Sequence.getInstance(aIn.readObject());
      } catch (IllegalArgumentException var1) {
         throw new IOException("not an ASN.1 Sequence: " + var1);
      }
   }

   public X509Principal(byte[] bytes) {
      super(readSequence(new ASN1InputStream(bytes)));
   }

   public X509Principal(X509Name name) {
      super((ASN1Sequence)name.getDERObject());
   }

   public X509Principal(Hashtable attributes) {
      super(attributes);
   }

   public X509Principal(Vector ordering, Hashtable attributes) {
      super(ordering, attributes);
   }

   public X509Principal(Vector oids, Vector values) {
      super(oids, values);
   }

   public X509Principal(String dirName) {
      super(dirName);
   }

   public X509Principal(boolean reverse, String dirName) {
      super(reverse, dirName);
   }

   public X509Principal(boolean reverse, Hashtable lookUp, String dirName) {
      super(reverse, lookUp, dirName);
   }

   public String getName() {
      return this.toString();
   }

   public byte[] getEncoded() {
      ByteArrayOutputStream var1;
      ByteArrayOutputStream var10000 = var1 = new ByteArrayOutputStream;
      var10000.<init>();
      X509Principal var10002 = this;
      DEROutputStream var10001 = new DEROutputStream(var1);

      try {
         var10001.writeObject(var10002);
      } catch (IOException var2) {
         throw new RuntimeException(var2.toString());
      }

      return var10000.toByteArray();
   }
}
